<template>
    <div id="tanks" class="content">
        <div class="header">
            <h2>Tanks</h2>
        </div>
        <div class="container-fluid">
            <div class="row">
                <!-- Reactor Starts -->
                <div class="col-md-4 mt-5 mt-md-0">
                    <div class="panel h-100">
                        <div class="panel-heading">Reactor</div>
                        <div class="panel-body">
                            <div class="d-flex justify-content-sm-center justify-content-end">
                                <tank-component :font-size="14" class="position-relative" height="25rem" status="on" value="50" width="20rem">
                                    <two-way-horizontal-valve-component :status="setDeviceIconStatus('TCV102')" class="position-absolute mb-1" label-top="TCV102" position="left" style="top: 9%; left: -16%" width="8rem"></two-way-horizontal-valve-component>
                                    <two-way-horizontal-valve-component :status="setDeviceIconStatus('TCV103')" class="position-absolute mb-1" label-top="TCV103" position="left" style="top: 28.5%; left: -16%" width="8rem"></two-way-horizontal-valve-component>
                                    <two-way-horizontal-valve-component :status="setDeviceIconStatus('TCV104')" class="position-absolute mb-1" label-top="TCV104" position="left" style="top: 46.5%; left: -16%" width="8rem"></two-way-horizontal-valve-component>
                                    <two-way-horizontal-valve-component :status="setDeviceIconStatus('TCV105')" class="position-absolute mb-1" label-top="TCV105" position="left" style="top: 65%; left: -16%" width="8rem"></two-way-horizontal-valve-component>
                                </tank-component>
                            </div>

                            <div class="container mt-5 px-0">
                                <div class="row">
                                    <div class="col-6">
                                        <div class="panel h-100">
                                            <div class="panel-heading">
                                                Overview
                                            </div>
                                            <div class="panel-body">
                                                <div class="row">
                                                    <div class="col-6">Batch No.</div>
                                                    <div class="col-6 font-weight-bold">5</div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">Load cell</div>
                                                    <div class="col-6 font-weight-bold">1200 KG</div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">Time elapse</div>
                                                    <div class="col-6 font-weight-bold">3h 32m</div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">PHT101</div>
                                                    <div class="col-6 font-weight-bold">
                                                        {{ setDevicePH('PHT101_ph') }}
                                                    </div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">RCT101</div>
                                                    <div class="col-6 font-weight-bold">
                                                        {{ setDeviceInverterPV('RCT101_INV_inverter') }}
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-6">
                                        <div class="panel">
                                            <div class="panel-heading">
                                                Material breakdown
                                            </div>
                                            <div class="panel-body">
                                                <div class="row">
                                                    <div class="col-6">Formid Acid</div>
                                                    <div class="col-6 font-weight-bold">200 KG</div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">Teric acid</div>
                                                    <div class="col-6 font-weight-bold">250 KG</div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">Ammonia</div>
                                                    <div class="col-6 font-weight-bold">250 KG</div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">Peroxide</div>
                                                    <div class="col-6 font-weight-bold">450 KG</div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">Latex</div>
                                                    <div class="col-6 font-weight-bold">40 KG</div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">Water</div>
                                                    <div class="col-6 font-weight-bold">10 KG</div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="container mt-4">
                                <div class="row">
                                    <div class="col-12">
                                        <reactor-material-chart-component></reactor-material-chart-component>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- Reactor End -->

                <!-- Mixing Starts -->
                <div class="col-md-4 mt-5 mt-md-0">
                    <div class="panel h-100">
                        <div class="panel-heading">Mixing</div>
                        <div class="panel-body">
                            <div class="flex-center">
                                <tank-component :font-size="16" class="position-relative" height="25rem" status="on" value="50" width="20rem"></tank-component>
                            </div>

                            <div class="container mt-5 px-0">
                                <div class="row">
                                    <div class="col-6">
                                        <div class="panel">
                                            <div class="panel-heading">
                                                Overview
                                            </div>
                                            <div class="panel-body">
                                                <div class="row">
                                                    <div class="col-6">Batch No.</div>
                                                    <div class="col-6 font-weight-bold">5</div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">Load cell</div>
                                                    <div class="col-6 font-weight-bold">1200 KG</div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">Time elapse</div>
                                                    <div class="col-6 font-weight-bold">3h 32m</div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">PHT102</div>
                                                    <div class="col-6 font-weight-bold">
                                                        {{ setDevicePH('PHT102_ph') }}
                                                    </div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">RCT102</div>
                                                    <div class="col-6 font-weight-bold">
                                                        {{ setDeviceInverterPV('RCT102_INV_inverter') }}
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-6">
                                        <div class="panel">
                                            <div class="panel-heading">
                                                Material breakdown
                                            </div>
                                            <div class="panel-body">
                                                <div class="row">
                                                    <div class="col-6">Enzyme</div>
                                                    <div class="col-6 font-weight-bold">200 KG</div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">HNS</div>
                                                    <div class="col-6 font-weight-bold">250 KG</div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">Teric Acid</div>
                                                    <div class="col-6 font-weight-bold">250 KG</div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">Latex</div>
                                                    <div class="col-6 font-weight-bold">450 KG</div>
                                                </div>
                                                <div class="row mt-2">
                                                    <div class="col-6">Water</div>
                                                    <div class="col-6 font-weight-bold">50 KG</div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="container mt-5">
                                <div class="row">
                                    <div class="col-12">
                                        <mixing-material-chart-component></mixing-material-chart-component>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- Mixing End -->

                <!-- Storage Start -->
                <div class="col-md-4 mt-5 mt-md-0">
                    <div class="panel h-100">
                        <div class="panel-heading">Storage</div>
                        <div class="panel-body">
                            <div class="flex-center">
                                <tank-component :font-size="16" class="position-relative" height="25rem" status="on" value="50" width="20rem"></tank-component>
                            </div>

                            <div class="container">
                                <div class="row mt-5 component">
                                    <div class="col-6">
                                        <div>RCT103</div>

                                        <div class="row">
                                            <div class="col-4">
                                                <div class="font-weight-normal">Status</div>
                                                <div class="font-weight-normal">PV</div>
                                            </div>
                                            <div class="col-8">
                                                <div :class="setDeviceStatusClass('RCT103')" class="font-weight-normal">
                                                    {{ setDeviceStatusText('RCT103') }}
                                                </div>
                                                <div class="font-weight-normal">
                                                    {{ setDeviceInverterSV('RCT103_INV_inverter') }}
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-6 d-flex align-items-end justify-content-between">
                                        <div class="font-weight-normal">SV</div>
                                        <div class="font-weight-normal">
                                            {{ setDeviceInverterPV('RCT103_INV_inverter') }}
                                        </div>
                                    </div>
                                </div>

                                <div class="row mt-4 component">
                                    <div class="col-6">
                                        <div>LT103</div>

                                        <div class="row">
                                            <div class="col-4">
                                                <div class="font-weight-normal">Level</div>
                                            </div>
                                            <div class="col-8">
                                                <div class="font-weight-normal">
                                                    {{ setDeviceLevel('LT103_level') }}
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- Storage End -->
            </div>

        </div>
    </div>
</template>

<script>
import Tank from '../../components/productions/Tank'
import TwoWayHorizontalValveComponent from '../../components/productions/TwoWayHorizontalValve'
import MixingMaterialChart from './MixingMaterialChart'
import ReactorMaterialChart from './ReactorMaterialChart'
import deviceMixin from "../../mixins/device";
import {topics} from "../../utils/mqtt-topics";

export default {
    name: 'tanks-component',
    mixins: [
        deviceMixin
    ],
    components: {
        'tank-component': Tank,
        'two-way-horizontal-valve-component': TwoWayHorizontalValveComponent,
        'mixing-material-chart-component': MixingMaterialChart,
        'reactor-material-chart-component': ReactorMaterialChart
    },
    data() {
        return {
            device: {},
            topics: topics.tanksPage
        }
    },
    mqtt: {
        'lgm/device/+'(message, topic) {
            console.log("\nTanks - Received message from " + topic + " topic at " + new Date().toLocaleString())
            console.log("Tanks - The message was " + message.toString());

            message = JSON.parse(message.toString());

            this.$set(this.device, message.device_id + '_' + message.type, message);
        },
        'lgm/data/+/+'(message, topic) {
            console.log("\nTanks - Received message from " + topic + " topic at " + new Date().toLocaleString())
            console.log("Tanks - The message was " + message.toString());

            message = JSON.parse(message.toString());

            this.$set(this.device, message.device_id + '_' + message.type, message);
        }
    },
    mounted() {
        this.$mqtt.subscribe(this.topics, function (err, granted) {
            if (err) {
                console.log("Tanks - Error During Subscription :" + err);
            } else {
                console.log("Tanks - No Error During Subscription");
            }
            if (granted !== undefined) {
                granted.forEach(function (grant) {
                    console.log("Tanks - Subscribed to topic " + grant.topic);
                })
            }
        });
    },
    beforeDestroy() {
        if (this.topics.length > 0) {
            this.$mqtt.unsubscribe(this.topics);
        }
    }
}
</script>

<style lang="scss">
@import "../../assets/styles/pages/tanks/tanks.scss";
</style>
